package com.kroud.swing.jpa.model;

import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.Date;

@Entity
@TableGenerator(name = "IDNR-seq", initialValue = 0, allocationSize = 1)
public class Patient {

    @Id
    @GeneratedValue(generator = "increment")
    @GenericGenerator(name = "increment", strategy = "increment")
    private Long id;

    private String vorname;
    private String name;
    private String geschlecht;
    //TODO in der GUI
    private String unvertaeglichkeit;
    private String diagnose;
    private String befund;
    private String therapie;

    //dd-MM-yyyy" 02-02-2000
    private Date geburtsdatum;
    private Date besuchsdatum; //TODO


    public Patient() {
    }

    public Patient(String name, String vorname, String geschlecht, String unvertaeglichkeit,
                   String diagnose, String befund, String therapie, Date geburtsdatum, Date besuchsdatum) {
        this.name = name;
        this.vorname = vorname;
        this.geschlecht = geschlecht;
        this.unvertaeglichkeit = unvertaeglichkeit;
        this.diagnose = diagnose;
        this.befund = befund;
        this.therapie = therapie;
        this.geburtsdatum = geburtsdatum;
        this.besuchsdatum = besuchsdatum;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getVorname() {
        return vorname;
    }

    public void setVorname(String vorname) {
        this.vorname = vorname;
    }

    public String getGeschlecht() {
        return geschlecht;
    }

    public void setGeschlecht(String geschlecht) {
        this.geschlecht = geschlecht;
    }

    public String getUnvertaeglichkeit() {
        return unvertaeglichkeit;
    }

    public void setUnvertaeglichkeit(String unvertaeglichkeit) {
        this.unvertaeglichkeit = unvertaeglichkeit;
    }

    public String getDiagnose() {
        return diagnose;
    }

    public void setDiagnose(String diagnose) {
        this.diagnose = diagnose;
    }

    public String getBefund() {
        return befund;
    }

    public void setBefund(String befund) {
        this.befund = befund;
    }

    public String getTherapie() {
        return therapie;
    }

    public void setTherapie(String therapie) {
        this.therapie = therapie;
    }

    public Date getGeburtsdatum() {
        return geburtsdatum;
    }

    public void setGeburtsdatum(Date geburtsdatum) {
        this.geburtsdatum = geburtsdatum;
    }

    public Date getBesuchsdatum() {
        return besuchsdatum;
    }

    public void setBesuchsdatum(Date besuchsdatum) {
        this.besuchsdatum = besuchsdatum;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getId() {
        return id;
    }

    @Override
    public String toString() {
        return "Patient{" +
                "id=" + id +
                ", vorname='" + vorname + '\'' +
                ", name='" + name + '\'' +
                ", geschlecht='" + geschlecht + '\'' +
                ", unvertaeglichkeit='" + unvertaeglichkeit + '\'' +
                ", diagnose='" + diagnose + '\'' +
                ", befund='" + befund + '\'' +
                ", therapie='" + therapie + '\'' +
                ", geburtsdatum=" + geburtsdatum +
                ", besuchsdatum=" + besuchsdatum +
                '}';
    }
}
