package com.kroud.swing.ui.controller;

import com.kroud.swing.jpa.model.Patient;
import com.kroud.swing.jpa.service.ArtztBesuch;
import com.kroud.swing.jpa.service.PatientAnlegen;
import com.kroud.swing.jpa.service.PatientenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.stream.Collectors;

import static javax.swing.WindowConstants.EXIT_ON_CLOSE;

@Controller
public class PatientenController { //extends JFrame{

    private final PatientenService patientenService;

    PatientAnlegen patientAnlegen = new PatientAnlegen();
    Patient patient = new Patient();
    ArtztBesuch artztBesuch = new ArtztBesuch();

    //Frame
    public JFrame f = new JFrame("Patientenakte"); //creating instance of JFrame

    JButton neuerPatient = new JButton("Neuer Patient");//creating instance of JButton
    JButton patientenSuchen = new JButton("Patient suchen");
    JButton suchen = new JButton("Suchen");
    JButton speichern = new JButton("Speichern");
    JButton bearbeiten = new JButton("Bearbeiten");

    public JLabel listLabel = new JLabel("Liste alle Patienten:");;
    JPanel patientenPanel = new JPanel();
    JList  patientenList = new JList();
    /*Buttons */
    public JLabel name;

    JMenuItem Weiblich;
    JMenuItem Maennlich;

    @Autowired
    public PatientenController(PatientenService patientenService) {
        this.patientenService = patientenService;

        f.setDefaultCloseOperation(EXIT_ON_CLOSE);
        f.pack();

        patientenSuchenButton();
        neuerPatientButton();

        // Array für unsere JList
        String patients[] = patientenService.getPatients().stream().map(p->p.getName()).toArray(String[]::new);

        patientenList= new JList(patients);
        patientenList.setSelectedIndex(0);
        patientenPanel.add(patientenList);

        //JFrame
        f.add(listLabel);
        f.add(patientenPanel);
        f.add(neuerPatient);//adding button in JFrame
        f.add(patientenSuchen);
        f.setSize(500, 500);
        f.setLayout(new FlowLayout(FlowLayout.CENTER, 160, 20));
        f.setVisible(true);//making the frame visible
    }

    public void patientenSuchenButton() {
        patientenSuchen.setBounds(100, 170, 200, 40);

        ActionListener action = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                suchenFrame();
            }
        };
        patientenSuchen.addActionListener(action);

    }

    private void neuerPatientButton() {

        neuerPatient.setBounds(100, 120, 200, 40);//x axis, y axis, width, height

        ActionListener action = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                neuerPatientFrame();
            }
        };
        neuerPatient.addActionListener(action);
    }

    private void suchenFrame() {
        //Jframe für suchen
        JFrame suchenFrame = new JFrame("Patienten suchen");
        suchenFrame.setSize(500, 500);//700 width and 700 height
        suchenFrame.setLayout(null);//using no layout managers
        suchenFrame.setVisible(true);//making the frame visible

        JLabel Titel = new JLabel("Patienten suchen");
        Titel.setBounds(200, 50, 200, 30);
        JLabel name = new JLabel("Name:");
        name.setBounds(50, 150, 100, 30);
        JTextField nameTextfeld = new JTextField();
        nameTextfeld.setBounds(200, 150, 150, 30);
        JLabel nachname = new JLabel("Nachname:");
        nachname.setBounds(50, 200, 100, 30);
        //nachname.setBorder(BorderFactory.createLineBorder(Color.WHITE)); //Optional Itar dial Jlabel
        JTextField nachnameTextfeld = new JTextField();
        nachnameTextfeld.setBounds(200, 200, 150, 30);

        /* Geburtsdatum */
        JLabel geburtsdatum = new JLabel("Geburtsdatum:");
        geburtsdatum.setBounds(50, 250, 100, 30);
        JTextField geburtsdatumTextfeld = new JTextField();
        geburtsdatumTextfeld.setBounds(200, 250, 150, 30);

        JLabel resultL = new JLabel("Result:");
        resultL.setBounds(10, 350, 100, 30);
        JLabel result = new JLabel("");
        result.setBounds(50, 350, 1300, 30);

        suchen.setBounds(100, 300, 100, 30);
        ActionListener action = new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                if (nameTextfeld.getText() != null) {
                    Patient gesuchterPatient = patientenService.findPatientByName(nameTextfeld.getText());
                    if (gesuchterPatient != null) {
                        System.out.println("Gefundene Eintrag in DB: " + gesuchterPatient.toString());
                        result.setText(gesuchterPatient.toString());

                        /*JFrame patient = new JFrame("Patient");
                        patient.setSize(500, 500);//700 width and 700 height
                        patient.setLayout(null);//using no layout managers
                        patient.setVisible(true);//making the frame visible */
                    }else{
                        result.setText("Patienen mit Name " + nameTextfeld.getText() + " wurde nicht gefunden!");
                    }
                }

            }
        };
       suchen.addActionListener(action);
        //Komponente in Frame hinzufügen
        suchenFrame.add(name);
        suchenFrame.add(nachname);
        suchenFrame.add(geburtsdatum);
        suchenFrame.add(nameTextfeld);
        suchenFrame.add(nachnameTextfeld);
        suchenFrame.add(geburtsdatumTextfeld);
        suchenFrame.add(suchen);
        suchenFrame.add(resultL);
        suchenFrame.add(result);
        suchenFrame.add(Titel);
    }

    private void neuerPatientFrame() {
        JFrame neuerPatient = new JFrame("Neuer Patient");
        neuerPatient.setSize(800, 800);//700 width and 700 height
        neuerPatient.setLayout(null);//using no layout managers
        neuerPatient.setVisible(true);//making the frame visible

        JLabel Titel = new JLabel("Neuer Patient");
        Titel.setBounds(300, 50, 150, 30);


        name = new JLabel("Name:");
        name.setBounds(50, 150, 100, 30);
        JTextField nameTextfeld = new JTextField();
        nameTextfeld.setBounds(200, 150, 150, 30);
        //patient.setname(nameTextfeld.getText());

        JLabel nachname = new JLabel("Nachname:");
        nachname.setBounds(50, 200, 100, 30);
        //nachname.setBorder(BorderFactory.createLineBorder(Color.WHITE)); //Optional Itar dial Jlabel
        JTextField nachnameTextfeld = new JTextField();
        nachnameTextfeld.setBounds(200, 200, 150, 30);
        /* Geburtsdatum */
// TODO https://www.codejava.net/java-se/swing/how-to-use-jdatepicker-to-display-calendar-component
        JLabel geburtsdatum = new JLabel("Geburtsdatum:");
        geburtsdatum.setBounds(50, 250, 100, 30);
        //JXDatePicker picker = new JXDatePicker();
        // picker.setDate(Calendar.getInstance().getTime());
        //picker.setFormats(new SimpleDateFormat("dd.MM.yyyy"));
        JTextField geburtsdatumTextfeld = new JTextField();
        geburtsdatumTextfeld.setBounds(200, 250, 150, 30);

        JLabel geschlecht = new JLabel("Geschlecht:");
        geschlecht.setBounds(50, 300, 100, 30);
        String G[] = {"Weiblich", "Männlich"};
        JComboBox wahlFeld = new JComboBox(G);
        wahlFeld.setBounds(200, 300, 150, 30);


        JLabel unv = new JLabel("Unverträglichkeit:");
        unv.setBounds(50, 350, 100, 30);
        String U[]={"Fructoseintoleranz","Milchzuckerunverträglichkeit", "Glutenunverträglichkeit (Zöliakie)","Weizensensitivität","Histaminintoleranz", "Sonstige..","keine Unverträglichkeiten"};
        JComboBox wahlFeld1=new JComboBox(U);
        wahlFeld1.setBounds(200,350,200,30);

        JLabel diagnose = new JLabel("Diagnose: ");
        diagnose.setBounds(50, 400, 100, 30);
        JTextField diagnoseTextfeld = new JTextField();
        diagnoseTextfeld.setBounds(200, 400, 150, 30);

        JLabel therapie = new JLabel("Therapie: ");
        therapie.setBounds(50, 450, 100, 30);
        JTextField therapieTextfeld = new JTextField();
       therapieTextfeld.setBounds(200, 450, 150, 30);

        JLabel befund = new JLabel("Befund: ");
       befund.setBounds(50, 500, 100, 30);
       JTextField befundTextfeld = new JTextField();
       befundTextfeld.setBounds(200, 500, 150, 30);


        JLabel besuchsdatum = new JLabel("Besuchsdatum:");
        besuchsdatum.setBounds(50, 550, 100, 30);
        JTextField besuchsdatumTextfeld = new JTextField();
       besuchsdatumTextfeld.setBounds(200, 550, 150, 30);

        // Button Speichern  in Fenster Neuer Patient Hinzufuegen.
        speichern.setBounds(300, 600, 150, 30);
        ActionListener action = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // patientAnlegen.angabenSpeichern();
                System.out.println("--------------------------Butto speicher-------------");
                patient.setName(nameTextfeld.getText());
                System.out.print(nameTextfeld.getText());
                System.out.print("   GebDaaaaaa  " + geburtsdatumTextfeld.getText());
                System.out.print("   Geschlecht  " + wahlFeld.getSelectedItem().toString() + " ");

                //Persistieren--> in der Datenbank speichern
                System.out.println("--------------------------main-------------");
                Patient p = null;
                try {
                    p = patientAnlegen.legePatientAn(nameTextfeld.getText(), nachnameTextfeld.getText(), wahlFeld.getSelectedItem().toString(),
                            wahlFeld1.getSelectedItem().toString(), diagnoseTextfeld.getText(), befundTextfeld.getText(), therapieTextfeld.getText(),
                            new SimpleDateFormat("dd.MM.yyyy").parse(geburtsdatumTextfeld.getText()),new SimpleDateFormat("dd.MM.yyyy").parse(besuchsdatumTextfeld.getText()));
                } catch (ParseException ex) {
                    ex.printStackTrace();
                }

                patientenService.createPatient(p); //in DB speichern
                JLabel Patient = new JLabel("Patient ist gespeichert");
                Patient.setBounds(50, 650, 200, 30);
                neuerPatient.add(Patient);
            }
        };
        speichern.addActionListener(action);
        //service.entityManager.close();


        neuerPatient.add(Titel);
        neuerPatient.add(name);
        neuerPatient.add(nameTextfeld);
        neuerPatient.add(nachname);
        neuerPatient.add(nachnameTextfeld);
        neuerPatient.add(geburtsdatum);
        neuerPatient.add(geburtsdatumTextfeld);
        neuerPatient.add(geschlecht);
        neuerPatient.add(wahlFeld);
        neuerPatient.add(unv);
        neuerPatient.add(wahlFeld1);
        neuerPatient.add(therapie);
        neuerPatient.add(therapieTextfeld);
        neuerPatient.add(befund);
        neuerPatient.add(befundTextfeld);
        neuerPatient.add(diagnose);
        neuerPatient.add(diagnoseTextfeld);
        neuerPatient.add(besuchsdatum);
        neuerPatient.add(besuchsdatumTextfeld);
        neuerPatient.add(speichern);


    }
}