package com.kroud.swing.ui.view;

import com.intellij.uiDesigner.core.GridConstraints;
import com.intellij.uiDesigner.core.GridLayoutManager;

import javax.swing.*;
import java.awt.*;

/**
 * We make this view abstract so that we can implement actions without having to know anything going on under
 * the hood. Anything to do with manipulating the actual View is done here, while manipulating the Model is done
 * in the Controller, which makes a concrete implementation of this view.
 *
 * Most of the code here gets generated by IntelliJ IDEA's GUI Designer.
 */
public abstract class JournalView {
    private JPanel mainPanel;
    private JList journalEntryList;
    private JButton newEntryButton;
    private JButton viewEntryButton;

    protected abstract void newEntryButtonClicked();

    protected abstract void viewEntryButtonClicked();

    public Object getSelectedEntry() {
        return journalEntryList.getSelectedValue();
    }

    @SuppressWarnings("unchecked")
    public void setJournalEntryListContent(Object[] contents) {
        journalEntryList.setListData(contents);
    }

    protected JournalView() {
        //"event" is definitely not used anywhere, in case you were trying to figure that out.
        newEntryButton.addActionListener(event -> newEntryButtonClicked());
        viewEntryButton.addActionListener(event -> viewEntryButtonClicked());
    }

    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        mainPanel = new JPanel();
        mainPanel.setLayout(new GridLayoutManager(2, 1, new Insets(0, 0, 0, 0), -1, -1));
        mainPanel.setMinimumSize(new Dimension(420, 420));
        mainPanel.setPreferredSize(new Dimension(420, 420));
        mainPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Ugly Journal"));
        journalEntryList = new JList();
        mainPanel.add(journalEntryList, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_WANT_GROW, null, new Dimension(150, 50), null, 0, false));
        final JPanel panel1 = new JPanel();
        panel1.setLayout(new GridLayoutManager(1, 2, new Insets(0, 0, 0, 0), -1, -1));
        mainPanel.add(panel1, new GridConstraints(1, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, null, null, null, 0, false));
        newEntryButton = new JButton();
        newEntryButton.setText("New Entry");
        panel1.add(newEntryButton, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_HORIZONTAL, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
        viewEntryButton = new JButton();
        viewEntryButton.setText("View Entry");
        panel1.add(viewEntryButton, new GridConstraints(0, 1, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_HORIZONTAL, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return mainPanel;
    }
}
